import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * A JFrame to host the plotter panel
 * 
 * @version 1.0 Feb. 2010
 * @author Euler
 *
 */
public class Graphic extends JFrame
{

	static int verbose = 0;
	static int xsize = 800;
	static int ysize = 550;
	private static String version ="1.0 Feb. 2010";

	Plotter plotter = null;
	JTextField status = new JTextField();

	/**
	 * 
	 * 
	 */
	public Graphic() {
		this( "Graphic " + version );
	}

	public Graphic(String string) {
		System.out.println("creating  Graphic ");
		setName(string);
		setTitle(string);
		setSize(xsize, ysize);
		Component contents = svCreateComponents();
		getContentPane().add(contents, BorderLayout.CENTER);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		pack();
		setVisible(true);
		System.out.println("Graphic completed ");
	}

	/**
	 * create all components (buttons, sliders, views, etc and arrange them
	 */
	public Component svCreateComponents() {

		plotter = new Plotter("Plotter");
		plotter.setPreferredSize(new Dimension(500, 300));

		// now combine all panes into base pane
		JPanel basePane = new JPanel();
		basePane.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		basePane.setLayout(new BorderLayout());
		basePane.add("Center", plotter);
		basePane.add("North", status);

		return basePane;
	}


	/**
	 * 
	 */

	public static void main(String[] args) throws Exception {
		Graphic graphic = new Graphic();
		Plotter plotter = graphic.getPlotter();
		plotter.setAutoYgrid(.5);
		plotter.setAutoXgrid(.5);
		plotter.setYLine(1);
		plotter.setYLine(-1);
		plotter.setXLine(Math.PI);

		for (double x = 0; x < 2 * Math.PI; x += 0.05) {
			double y = Math.sin(x);
			plotter.add("sin2", x, y);
			plotter.add("sin", x, y * y);
		}
	}

	/**
	 * @return the plotter
	 */
	public Plotter getPlotter() {
		return plotter;
	}

	/**
	 * @param plotter the plotter to set
	 */
	public void setPlotter(Plotter plotter) {
		this.plotter = plotter;
	}

	/**
	 * 
	 */
	public void paint(Graphics g) {
		status.setText( plotter.getStatusLine() );
		super.paint(g);
	}


}
